% fn_clean_pce.m
% Function to clean PCE series by removing abnormal vintages.
%  [pcepm_rt,pcepm_core_rt]=fn_clean_pce(pcepm_rt,pcepm_core_rt);
%
% The function loads the raw data and deletes two abnormal columns.
%
% Inputs:
% pcepm_x - The original PCE-based data
%
% Outputs:
% pcepm_x - The new cleaned data
%
function [pcepm_rt,pcepm_core_rt]=fn_clean_pce(pcepm_rt,pcepm_core_rt);
%
% remove December 23, 2003, vintage (too short to be useful, full series released on January 5, 
% 2004) and August 4, 2009, vintage (does not contain full series; full series released the 
% following day)
i1=pcepm_rt(1,:)~=20031223 & pcepm_rt(1,:)~=20090804;
pcepm_rt=pcepm_rt(:,i1);
i1=pcepm_core_rt(1,:)~=20031223 & pcepm_core_rt(1,:)~=20090804;
pcepm_core_rt=pcepm_core_rt(:,i1);