% fn_compute_initial_m.m
% Function to compute initial growth rates for monthly data.
%  g_x=fn_compute_initial_m(date_m,x_rt);
%
% The function takes the real-time dataset and computes the initial
% monthly (non-annualized) inflation readings as percent changes.
%
% Inputs:
% date_m - A vector with monthly dates.
% x_rt - A matrix of real-time price levels.
% 
% Outputs:
% g_x - A vector with dimensionality date_m of initial inflation readings.
%
function g_x=fn_compute_initial_m(date_m,x_rt);
%
global junk_nos;
%
g_x=junk_nos*ones(size(date_m));
% loop over incoming data
for i1=2:size(x_rt,2);
	i2=max(find(x_rt(:,i1)~=junk_nos));
	i3=find(date_m==x_rt(i2,1));
	if x_rt(i2,i1)~=junk_nos & x_rt(i2-1,i1)~=junk_nos;
		g_x(i3)=100*(x_rt(i2,i1)/x_rt(i2-1,i1)-1);
	end;
end;