% fn_make_forecast_ma.m
% Function to make forecasts using moving averages over the past J_ months.
%  f_g_p=fn_make_forecast_ma(g_p);
%
% Input:
% g_p - Vector of monthly inflation rates.
%
% Output: 
% f_g_p - Vector of monthly inflation rates and forecasts.
%
function [f_g_p,txt]=fn_make_forecast_ma(g_p);
%
global junk_nos J_;
%
f_g_p=g_p;
f1=max(find(g_p~=junk_nos));
L=length(f_g_p);
for i1=f1:L-1;
	f_g_p(i1+1)=mean(f_g_p(i1-J_+1:i1));
end;
txt=['dynamic moving average forecast from last ',num2str(J_),' months'];