% fn_mtoqavg.m
% Function to convert to quarterly averages.
%  [z,g_z]=fn_mtoqavg(x,date_m,date_q);
%
% The function takes the monthly data and converts to quarterly averages
% and computes quarterly growth rates.  It requires all three months of
% a quarter be present.
%
% Inputs:
% x - A vector of monthly data
% date_m - A vector with monthly dates
% date_q - A vector with quarterly dates
%
% Outputs:
% z - A vector with quarterly averages
% g_z - A vector with quarterly growth rates
%
function [z,g_z]=fn_mtoqavg(x,date_m,date_q);
% 
global junk_nos;
%
n=length(date_q);
z=junk_nos*ones(n,1);
g_z=junk_nos*ones(n,1);
date_q_conv=round(date_q)+3*(round(10*(date_q-round(date_q)))/10)/10;
first_m=date_m(1);
for i1=1:n;
	if date_q(i1)>first_m;
		f1=find(date_q_conv(i1)==date_m);
		if f1>2;
			temp=x(f1-2:f1);
			if sum(temp==junk_nos)==0;
				z(i1)=mean(temp);
				if i1>1 & z(i1-1)~=junk_nos;
					g_z(i1)=100*((z(i1)/z(i1-1))^4-1);
				end;
			end;
		end;
	end;
end;