% nowcasting_inflation_other.m
% Program to produce other results.

% Load the data
nowcasting_inflation_setup;






%---------------------------------------------------------------------
disp('-------------------------------------------------------------------------------');
disp('Initial v. ''final'' inflation readings');
disp('-------------------------------------------------------------------------------');
%---------------------------------------------------------------------
g_initial_less_final_m=NaN*ones(length(junk_nos_m),8);
g_initial_less_final_q=NaN*ones(length(junk_nos_q),8);
g_initial_less_final_stats_m=NaN*ones(4,8);
g_initial_less_final_stats_q=NaN*ones(4,8);
for i1=1:2:7;
if i1==1;
	f1=g_cpi_initial;
	f2=g_cpi_final;
	f3=g_cpi_q_initial;
	f4=g_cpi_q_final;
end;
if i1==3;
	f1=g_cpi_core_initial;
	f2=g_cpi_core_final;
	f3=g_cpi_core_q_initial;
	f4=g_cpi_core_q_final;
end;
if i1==5;
	f1=g_pcepm_initial;
	f2=g_pcepm_final;
	f3=g_pcep_q_initial;
	f4=g_pcep_q_final;	
end;
if i1==7;
	f1=g_pcepm_core_initial;
	f2=g_pcepm_core_final;
	f3=g_pcep_core_q_initial;
	f4=g_pcep_core_q_final;	
end;
g_diff=NaN*ones(size(junk_nos_m));
i2=f1~=junk_nos & f2~=junk_nos & date_m<=last_month_with_revisions & date_m>=first_month_for_revisions;
g_diff(i2)=f1(i2)-f2(i2);
g_initial_less_final_stats_m(1,i1)=mean(g_diff(i2)); % average difference
g_initial_less_final_stats_m(2,i1)=std(g_diff(i2)); % standard deviation of difference
g_initial_less_final_stats_m(1,i1+1)=mean(abs(g_diff(i2))); % average absolute difference
g_initial_less_final_stats_m(2,i1+1)=std(abs(g_diff(i2))); % standard deviation of absolute difference
g_initial_less_final_stats_m(3,i1)=date_m(min(find(i2))); % start date
g_initial_less_final_stats_m(4,i1)=date_m(max(find(i2))); % end date
g_initial_less_final_m(:,i1)=g_diff;
g_diff=NaN*ones(size(junk_nos_q));
i2=f3~=junk_nos & f4~=junk_nos & date_q<=last_quarter_with_revisions & date_q>=first_quarter_for_revisions;
g_diff(i2)=f3(i2)-f4(i2);
g_initial_less_final_stats_q(1,i1)=mean(g_diff(i2)); % average difference
g_initial_less_final_stats_q(2,i1)=std(g_diff(i2)); % standard deviation of difference
g_initial_less_final_stats_q(1,i1+1)=mean(abs(g_diff(i2))); % average absolute difference
g_initial_less_final_stats_q(2,i1+1)=std(abs(g_diff(i2))); % standard deviation of absolute difference
g_initial_less_final_stats_q(3,i1)=date_q(min(find(i2))); % start date
g_initial_less_final_stats_q(4,i1)=date_q(max(find(i2))); % end date
g_initial_less_final_q(:,i1)=g_diff;
end;
% include dates:
date_g_initial_less_final_q=[date_q,g_initial_less_final_q];
% Table 1 data:
table_1=[g_initial_less_final_stats_m(1:2,:);g_initial_less_final_stats_q(1:2,:)];
% Figure 1a data:
i1=date_g_initial_less_final_q(:,1)>=2000.2 & date_g_initial_less_final_q(:,1)<=2014.4;
figure_1a=[date_g_initial_less_final_q(i1,[1,2,6])];
% Figure 1b data:
figure_1b=[date_g_initial_less_final_q(i1,[1,4,8])];






%---------------------------------------------------------------------
disp('-------------------------------------------------------------------------------');
disp('Monthly nowcasting exercise, Modugno (2013) comparison');
disp('-------------------------------------------------------------------------------');
%---------------------------------------------------------------------

no_cases_m=1;

disp(['Month to start the analysis: ',num2str(start_month_yoy_modugno)]);
disp(['Month to end the analysis: ',num2str(end_month_yoy_modugno)]);

% set matrices to store inflation nowcasts
% Year-over-year exercises
g_cpi_nowcasts_yoy=junk_nos_m*ones(1,no_cases_m);
g_cpi_nowcasts_yoy_rw=junk_nos_m*ones(1,no_cases_m);

%---------------------------------------------------------------------
for mcount=find(date_m==start_month_yoy_modugno):find(date_m==end_month_yoy_modugno);
%---------------------------------------------------------------------

yyyymm=date_m(mcount); % date of month of interest
yy=round(yyyymm);
mm=round(100*yyyymm-100*round(yyyymm));
ff=mcount; % position of the month of interest

case_count=1; % only 1 case to consider

% Date to set the dataset
i1=1+min(find(cpi_rt(mcount,2:end)~=junk_nos));
date_cutoff=cpi_rt(1,i1)+1; % day after the CPI release
ff_cpi=ff-1; % missing the current CPI 

%---------------------------------------------------------------------
% Set up available data
%---------------------------------------------------------------------
wcount=max(find(date_w<=date_cutoff));
dcount=max(find(date_d<=date_cutoff));
f1=min(find(cpi_rt(ff_cpi+1,2:end)~=junk_nos));
mcount_cpi=1+f1;
%
p_oil_d=junk_nos*ones(size(date_d));
p_oil_d(1:dcount)=p_oil_d_rt(1:dcount,2);
%
p_gasoline_w=junk_nos*ones(size(date_w));
p_gasoline_w(1:wcount)=p_gasoline_w_rt(1:wcount,2);
%
cpi=cpi_rt(2:end,mcount_cpi);
cpi_core=cpi_core_rt(2:end,mcount_cpi);
cpi_food=cpi_food_rt(2:end,mcount_cpi);
cpi_gasoline=cpi_gasoline_rt(2:end,mcount_cpi);
%
f_cpi=cpi;
%
g_cpi=fn_compute_g_monthly(cpi);
g_cpi_core=fn_compute_g_monthly(cpi_core);
g_cpi_food=fn_compute_g_monthly(cpi_food);
g_cpi_gasoline=fn_compute_g_monthly(cpi_gasoline);

%---------------------------------------------------------------------
% Make nowcasts
%---------------------------------------------------------------------
[f_g_cpi,f_g_cpi_core]=fn_make_nowcasts(date_m,date_d,date_w,...
	p_gasoline_w,p_oil_d,g_cpi,g_cpi_core,g_cpi_food,g_cpi_gasoline);	

%-------------------------
% Year-over-year inflation
%-------------------------
i1=max(find(f_cpi~=junk_nos));
for i2=i1+1:ff;
	f_cpi(i2)=f_cpi(i2-1)*(1+f_g_cpi(i2)/100);
end;
% Modugno computes year-over-year inflation using natural logs, do the same here
% for compatibility
g_cpi_nowcasts_yoy_rw(mcount,case_count)=100*log(f_cpi(i1)/f_cpi(i1-12));
g_cpi_nowcasts_yoy(mcount,case_count)=100*log(f_cpi(ff)/f_cpi(ff-12)); 

%---------------------------------------------------------------------
end; % mcount loop
%---------------------------------------------------------------------

disp('-------------------------------------------------------------------------------');
disp('Case: day after previous month''s CPI is released');
disp('-------------------------------------------------------------------------------');

%---------------------------------------------------------------------
% Compute forecast errors
%---------------------------------------------------------------------
rmses_m_cpi_yoy_rw=NaN*ones(1,no_cases_m);
rmses_m_cpi_yoy=NaN*ones(1,no_cases_m);
for i1=1:no_cases_m;
	% CPI, year-over-year exercises
	%
	% Random walk
	f1=g_cpi_nowcasts_yoy_rw(:,i1);
	a1=g_cpi_metric_yoy_dln;
	i2=f1~=junk_nos & a1~=junk_nos;
	r1=sqrt(mean((f1(i2)-a1(i2)).^2));
	rmses_m_cpi_yoy_rw(i1)=r1;	
	% Our model
	f1=g_cpi_nowcasts_yoy(:,i1);
	a1=g_cpi_metric_yoy_dln;
	i2=f1~=junk_nos & a1~=junk_nos;
	r1=sqrt(mean((f1(i2)-a1(i2)).^2));
	rmses_m_cpi_yoy(i1)=r1;
end;
disp('CPI year-over-year nowcasting, based on Modugno');
disp(['Random walk RMSE = ',num2str(rmses_m_cpi_yoy_rw)]);
disp(['Modugno (2013) RMSE = 0.23']);
disp(['Model RMSE = ',num2str(rmses_m_cpi_yoy)]);






%---------------------------------------------------------------------
% For horseraces, reload CPI data and use them as they are; i.e.,
% don't remove pure seasonal adjustments and don't change the lengths
% of any series
%---------------------------------------------------------------------
% Load real-time CPI data.
[cpi_rt]=xlsread('nowcast_inflation_data','cpi_raw');
% Load real-time core CPI data.
[cpi_core_rt]=xlsread('nowcast_inflation_data','cpi_core_raw');
% Load real-time CPI food data.
[cpi_food_rt]=xlsread('nowcast_inflation_data','cpi_food_raw');
% Load real-time CPI gasoline data.
[cpi_gasoline_rt]=xlsread('nowcast_inflation_data','cpi_gasoline_raw');

%---------------------------------------------------------------------
% Replace NaNs with junk_nos
%---------------------------------------------------------------------
cpi_rt(isnan(cpi_rt))=junk_nos;
cpi_core_rt(isnan(cpi_core_rt))=junk_nos;
cpi_food_rt(isnan(cpi_food_rt))=junk_nos;
cpi_gasoline_rt(isnan(cpi_gasoline_rt))=junk_nos;






%---------------------------------------------------------------------
disp('-------------------------------------------------------------------------------');
disp('Blue Chip horserace');
disp('-------------------------------------------------------------------------------');
%---------------------------------------------------------------------
% Compare the forecasting performance of the model with the consensus
% CPI forecasts from the Blue Chip Economic Indicators.  This is a 
% date-based horserace, so information sets are matched by date.  The
% Blue Chip consensus is the average of professional forecasters.  The
% survey is conducted usually in the first week of the month.  Thus, 
% there are four cases to consider.
% 1. Survey conducted at start of first month of the quarter of interest (e.g., January for Q1).
% 2. Survey conducted at start of second month of the quarter of interest (e.g., February for Q1).
% 3. Survey conducted at start of third month of the quarter of interest (e.g., March for Q1).
% 4. Survey conducted at start of first month in the quarter AFTER the quarter of interest
%    (but before final monthly CPI report is released) (e.g., April for Q1).
no_cases_bc=4;

% Load Blue Chip CPI nowcasts/forecasts.
[bcei_cpi_rt]=xlsread('nowcast_inflation_data','bcei_cpi');
bcei_cpi_rt(isnan(bcei_cpi_rt))=junk_nos;

disp(['Quarter to start the Blue Chip comparison: ',num2str(start_quarter_bcei)]);
disp(['Quarter to end the Blue Chip comparison: ',num2str(end_quarter_bcei)]);
 
% set matrices to store inflation nowcasts
g_cpi_q_bcei_model=junk_nos_q*ones(1,no_cases_bc);
g_cpi_q_bcei=junk_nos_q*ones(1,no_cases_bc);

% Directional forecast accuracy matrices
dfa_g_forecast_direction=junk_nos_q*ones(1,no_cases_bc);
dfa_g_data_direction=junk_nos_q*ones(1,no_cases_bc);
%
dfa_g_forecast_direction_other=junk_nos_q*ones(1,no_cases_bc);
dfa_g_data_direction_other=junk_nos_q*ones(1,no_cases_bc);

%---------------------------------------------------------------------
for qcount=find(date_q==start_quarter_bcei):find(date_q==end_quarter_bcei);
%---------------------------------------------------------------------

yyyyq=date_q(qcount);
yy=round(yyyyq); % year of the quarter under investigation
mm=3*(round(10*rem(yyyyq,1))-1)+1; % first month of the quarter under investigation
yyyymm=yy+mm/100; % date of first month of the quarter under investigation
ff=find(date_m==yyyymm); % ff is the position of the first month of the quarter under investigation

%---------------------------------------------------------------------
for case_count=1:no_cases_bc;
%---------------------------------------------------------------------

mm_case=ff+case_count-1;

%---------------------------------------------------------------------
if mm_case<=length(date_m); % check that in-bounds
%---------------------------------------------------------------------

date_cutoff=bcei_cpi_rt(1,1+min(find(bcei_cpi_rt(1,2:end)>10000*date_m(mm_case))));

%---------------------------------------------------------------------
% Set up available data
%---------------------------------------------------------------------
wcount=max(find(date_w<=date_cutoff));
dcount=max(find(date_d<=date_cutoff));
mcount_cpi=max(find(cpi_rt(1,:)<=date_cutoff));
mcount_cpi_core=max(find(cpi_core_rt(1,:)<=date_cutoff));
mcount_cpi_food=max(find(cpi_food_rt(1,:)<=date_cutoff));
mcount_cpi_gasoline=max(find(cpi_gasoline_rt(1,:)<=date_cutoff));
%
p_oil_d=junk_nos*ones(size(date_d));
p_oil_d(1:dcount)=p_oil_d_rt(1:dcount,2);
p_gasoline_w=junk_nos*ones(size(date_w));
p_gasoline_w(1:wcount)=p_gasoline_w_rt(1:wcount,2);
%
cpi=cpi_rt(2:end,mcount_cpi);
g_cpi=fn_compute_g_monthly(cpi);
cpi_core=cpi_core_rt(2:end,mcount_cpi_core);
g_cpi_core=fn_compute_g_monthly(cpi_core);
cpi_food=cpi_food_rt(2:end,mcount_cpi_food);
g_cpi_food=fn_compute_g_monthly(cpi_food);
cpi_gasoline=cpi_gasoline_rt(2:end,mcount_cpi_gasoline);
g_cpi_gasoline=fn_compute_g_monthly(cpi_gasoline);

%---------------------------------------------------------------------
% Make nowcasts
%---------------------------------------------------------------------
f_cpi=cpi;
[f_g_cpi]=fn_make_nowcasts(date_m,date_d,date_w,...
	p_gasoline_w,p_oil_d,g_cpi,g_cpi_core,g_cpi_food,g_cpi_gasoline);	

%-------------------------------
% Convert growth rates to levels
%-------------------------------
f2=max(find(cpi~=junk_nos));
for i1=f2+1:ff+2;
	f_cpi(i1)=f_cpi(i1-1)*(1+f_g_cpi(i1)/100);
end;

%------------------
% Save the nowcasts
%------------------
g_cpi_q_bcei_model(qcount,case_count)=100*((mean(f_cpi(ff:ff+2))/mean(f_cpi(ff-3:ff-1)))^4-1);
% Blue Chip predicted:
g_cpi_q_bcei(qcount,case_count)=bcei_cpi_rt(find(date_q(qcount)==bcei_cpi_rt(:,1)),find(date_cutoff==bcei_cpi_rt(1,:)));

%------------------------------
% Directional forecast accuracy
%------------------------------
% CPI
inf_model_this=g_cpi_q_bcei_model(qcount,case_count);
inf_model_last=100*((mean(f_cpi(ff-3:ff-1))/mean(f_cpi(ff-6:ff-4)))^4-1);
inf_actual=g_cpi_q_metric(qcount);
inf_alt=g_cpi_q_bcei(qcount,case_count);
inf_alt_last=bcei_cpi_rt(find(date_q(qcount)==bcei_cpi_rt(:,1))-1,find(date_cutoff==bcei_cpi_rt(1,:)));
% Nowcast
dfa_g_forecast_direction(qcount,case_count)=fn_dfa_up_indicator(inf_model_this,inf_model_last);
% Data
dfa_g_data_direction(qcount,case_count)=fn_dfa_up_indicator(inf_actual,inf_model_last);
% Blue Chip
if inf_alt_last==junk_nos; % data were available, but not in BC dataset
	dfa_g_forecast_direction_other(qcount,case_count)=fn_dfa_up_indicator(inf_alt,inf_model_last);
	dfa_g_data_direction_other(qcount,case_count)=fn_dfa_up_indicator(inf_actual,inf_model_last);
else; % use BC nowcast from previous quarter
	dfa_g_forecast_direction_other(qcount,case_count)=fn_dfa_up_indicator(inf_alt,inf_alt_last);
	dfa_g_data_direction_other(qcount,case_count)=fn_dfa_up_indicator(inf_actual,inf_alt_last);
end;

%---------------------------------------------------------------------
end; % in-bounds check
%---------------------------------------------------------------------

%---------------------------------------------------------------------
end; % case_count loop
%---------------------------------------------------------------------

%---------------------------------------------------------------------
end; % qcount loop
%---------------------------------------------------------------------

disp('-------------------------------------------------------------------------------');
disp('Case 1:');
disp('Start of first month of the quarter,');
disp('e.g., January for Q1.');
disp('-------------------------------------------------------------------------------');
disp('Case 2:');
disp('Start of the second month of the quarter,');
disp('e.g., February for Q1.');
disp('-------------------------------------------------------------------------------');
disp('Case 3:');
disp('Start of the third month of the quarter');
disp('e.g., March for Q1.');
disp('-------------------------------------------------------------------------------');
disp('Case 4:');
disp('Start of the first month following the quarter,');
disp('e.g., April for Q1 (before CPI released).');
disp('-------------------------------------------------------------------------------');

%---------------------------------------------------------------------
% Directional forecast accuracy
%---------------------------------------------------------------------
pt_tests_model=NaN(3,no_cases_bc);
pt_tests_other=NaN(3,no_cases_bc);
for i1=1:no_cases_bc;
	f1=dfa_g_forecast_direction(:,i1)~=junk_nos & dfa_g_data_direction(:,i1)~=junk_nos;
	[pt_tests_model(1,i1),pt_tests_model(2,i1),pt_tests_model(3,i1)]=fn_pesaran_timmermann_sc_dfa(dfa_g_forecast_direction(f1,i1),dfa_g_data_direction(f1,i1));
	f1=dfa_g_forecast_direction_other(:,i1)~=junk_nos & dfa_g_data_direction_other(:,i1)~=junk_nos;
	[pt_tests_other(1,i1),pt_tests_other(2,i1),pt_tests_other(3,i1)]=fn_pesaran_timmermann_sc_dfa(dfa_g_forecast_direction_other(f1,i1),dfa_g_data_direction_other(f1,i1));
end;
pt_tests_q_cpi_bcei_model=pt_tests_model;
pt_tests_q_cpi_bcei=pt_tests_other;

%---------------------------------------------------------------------
% Compute forecast errors
%---------------------------------------------------------------------
errors_q_cpi_bcei_model=NaN*ones(length(date_q),no_cases_bc);
errors_q_cpi_bcei=NaN*ones(length(date_q),no_cases_bc);
rmses_q_cpi_bcei_model=NaN*ones(1,no_cases_bc);
rmses_q_cpi_bcei=NaN*ones(1,no_cases_bc);
gwstat_sig_q_cpi_bcei_comp=NaN*ones(1,no_cases_bc);
no_obs_q_cpi_bcei_comp=NaN*ones(1,no_cases_bc);
for i1=1:no_cases_bc;
	% CPI
	f1=g_cpi_q_bcei_model(:,i1);
	% Blue Chip CPI
	f2=g_cpi_q_bcei(:,i1);
	% Actual
	a1=g_cpi_q_metric;
%%	i2=f1~=junk_nos & f2~=junk_nos & a1~=junk_nos;
	i2=f1~=junk_nos & a1~=junk_nos;
	% Errors & RMSE
	errors_q_cpi_bcei_model(i2,i1)=f1(i2)-a1(i2);
	rmses_q_cpi_bcei_model(i1)=sqrt(mean((errors_q_cpi_bcei_model(i2,i1)).^2));
	errors_q_cpi_bcei(i2,i1)=f2(i2)-a1(i2);
	rmses_q_cpi_bcei(i1)=sqrt(mean((errors_q_cpi_bcei(i2,i1)).^2));
	% number of observations
	no_obs_q_cpi_bcei_comp(i1)=sum(i2);
	% GW test
	[gw_teststat,gw_critval,gwstat_sig_q_cpi_bcei_comp(i1)]=CPAtest(errors_q_cpi_bcei_model(i2,i1).^2-errors_q_cpi_bcei(i2,i1).^2,ones(no_obs_q_cpi_bcei_comp(i1),1),1);
end;
% If have Blue Chip data:
% % Table 6 data:
% table_6=[rmses_q_cpi_bcei_model;rmses_q_cpi_bcei;...
% 	(rmses_q_cpi_bcei.^2)./(rmses_q_cpi_bcei_model.^2);...
% 	gwstat_sig_q_cpi_bcei_comp;...
% 	pt_tests_q_cpi_bcei_model(3,:);...
% 	pt_tests_q_cpi_bcei(3,:);...
% 	pt_tests_q_cpi_bcei_model(2,:);...
% 	pt_tests_q_cpi_bcei(2,:)];
% i1=date_q>=1999.2 & date_q<=2015.2;
% % Figure A1 data:
% figure_a1a=[date_q(i1),g_cpi_q_metric(i1),g_cpi_q_bcei_model(i1,1),g_cpi_q_bcei(i1,1)];
% figure_a1b=[date_q(i1),g_cpi_q_metric(i1),g_cpi_q_bcei_model(i1,2),g_cpi_q_bcei(i1,2)];
% figure_a1c=[date_q(i1),g_cpi_q_metric(i1),g_cpi_q_bcei_model(i1,3),g_cpi_q_bcei(i1,3)];
% i1=date_q>=1999.2 & date_q<=2015.1; % don't have 2015Q2
% figure_a1d=[date_q(i1),g_cpi_q_metric(i1),g_cpi_q_bcei_model(i1,4),g_cpi_q_bcei(i1,4)];
% 
% If not:
load table_6; % pre-populated with computed statistics based on Blue Chip nowcasts
% Table 6 data:
table_6(1,:)=rmses_q_cpi_bcei_model;
table_6(5,:)=pt_tests_q_cpi_bcei_model(3,:);
table_6(7,:)=pt_tests_q_cpi_bcei_model(2,:);
i1=date_q>=1999.2 & date_q<=2015.2;
% Figure A1 data:
figure_a1a=[date_q(i1),g_cpi_q_metric(i1),g_cpi_q_bcei_model(i1,1)];
figure_a1b=[date_q(i1),g_cpi_q_metric(i1),g_cpi_q_bcei_model(i1,2)];
figure_a1c=[date_q(i1),g_cpi_q_metric(i1),g_cpi_q_bcei_model(i1,3)];
i1=date_q>=1999.2 & date_q<=2015.1; % don't have 2015Q2
figure_a1d=[date_q(i1),g_cpi_q_metric(i1),g_cpi_q_bcei_model(i1,4)];





%---------------------------------------------------------------------
disp('-------------------------------------------------------------------------------');
disp('Survey of Professional Forecasters horserace');
disp('-------------------------------------------------------------------------------');
%---------------------------------------------------------------------
% Compare the forecasting performance of the model with the median
% CPI forecasts from the Survey of Professional Forecasters.  This is a 
% date-based horserace, so information sets are matched by date.  The SPF
% is conducted in the middle of the middle month of the quarter.

% Load SPF forecasts and convert to standardized form.
txt='median'; % use the median forecasts
[spf_cpi_rt,spf_cpi_core_rt,spf_pcep_rt,spf_pcep_core_rt]=fn_spf_to_standard_matrices(txt);
spf_cpi_rt(isnan(spf_cpi_rt))=junk_nos;
spf_cpi_core_rt(isnan(spf_cpi_core_rt))=junk_nos;
spf_pcep_rt(isnan(spf_pcep_rt))=junk_nos;
spf_pcep_core_rt(isnan(spf_pcep_core_rt))=junk_nos;

disp(['Quarter to start the SPF comparison: ',num2str(start_quarter_spf)]);
disp(['Quarter to end the SPF comparison: ',num2str(end_quarter_spf)]);
disp('Note: SPF core CPI, PCE, and core PCE all begin in 2007.1.');
disp('The CPI sample may be longer if you start before then.');
 
% set matrices to store inflation nowcasts
g_cpi_q_spf_model=junk_nos_q;
g_cpi_core_q_spf_model=junk_nos_q;
g_pcep_q_spf_model=junk_nos_q;
g_pcep_core_q_spf_model=junk_nos_q;
g_cpi_q_spf=junk_nos_q;
g_cpi_core_q_spf=junk_nos_q;
g_pcep_q_spf=junk_nos_q;
g_pcep_core_q_spf=junk_nos_q;

% Directional forecast accuracy matrices
dfa_g_forecast_direction=junk_nos*ones(length(date_q),1,4);
dfa_g_data_direction=junk_nos*ones(length(date_q),1,4);
%
dfa_g_forecast_direction_other=junk_nos*ones(length(date_q),1,4);
dfa_g_data_direction_other=junk_nos*ones(length(date_q),1,4);

%---------------------------------------------------------------------
for qcount=find(date_q==start_quarter_spf):find(date_q==end_quarter_spf);
%---------------------------------------------------------------------

yyyyq=date_q(qcount);
yy=round(yyyyq); % year of the quarter under investigation
mm=3*(round(10*rem(yyyyq,1))-1)+1; % first month of the quarter under investigation
yyyymm=yy+mm/100; % date of first month of the quarter under investigation
ff=find(date_m==yyyymm); % ff is the position of the first month of the quarter under investigation

mm_case=ff+1; % SPF comes out in the middle month of the quarter

date_cutoff=spf_cpi_rt(1,1+min(find(spf_cpi_rt(1,2:end)>10000*date_m(mm_case))));

%---------------------------------------------------------------------
% Set up available data
%---------------------------------------------------------------------
wcount=max(find(date_w<=date_cutoff));
dcount=max(find(date_d<=date_cutoff));
mcount_cpi=max(find(cpi_rt(1,:)<=date_cutoff));
mcount_cpi_core=max(find(cpi_core_rt(1,:)<=date_cutoff));
mcount_cpi_food=max(find(cpi_food_rt(1,:)<=date_cutoff));
mcount_cpi_gasoline=max(find(cpi_gasoline_rt(1,:)<=date_cutoff));
mcount_pcepm=max(find(pcepm_rt(1,:)<=date_cutoff));
if pce_switch;
pce_switch_temp=1;
if isempty(mcount_pcepm);
	pce_switch_temp=0;
end;
else pce_switch_temp=0;
end;
%
p_oil_d=junk_nos*ones(size(date_d));
p_oil_d(1:dcount)=p_oil_d_rt(1:dcount,2);
p_gasoline_w=junk_nos*ones(size(date_w));
p_gasoline_w(1:wcount)=p_gasoline_w_rt(1:wcount,2);
%
cpi=cpi_rt(2:end,mcount_cpi);
g_cpi=fn_compute_g_monthly(cpi);
cpi_core=cpi_core_rt(2:end,mcount_cpi_core);
g_cpi_core=fn_compute_g_monthly(cpi_core);
cpi_food=cpi_food_rt(2:end,mcount_cpi_food);
g_cpi_food=fn_compute_g_monthly(cpi_food);
cpi_gasoline=cpi_gasoline_rt(2:end,mcount_cpi_gasoline);
g_cpi_gasoline=fn_compute_g_monthly(cpi_gasoline);
% unfortunately, don't have real-time CPI--food at home (which 
% conceptually matches up with PCE--goods--food), use CPI--food instead
g_cpi_food_at_home=g_cpi_food;
%
if pce_switch & pce_switch_temp;
pcepm=pcepm_rt(2:end,mcount_pcepm);
g_pcepm=fn_compute_g_monthly(pcepm);
pcepm_core=pcepm_core_rt(2:end,mcount_pcepm);
g_pcepm_core=fn_compute_g_monthly(pcepm_core);
% unfortunately, don't have real-time PCE--goods--food, use CPI--food instead
g_pcepm_goods_food=g_cpi_food; 
else;
pcepm=[];
g_pcepm=[];
pcepm_core=[];
g_pcepm_core=[];
g_pcepm_goods_food=[];
end; % pce_switch

%---------------------------------------------------------------------
% Make nowcasts
%---------------------------------------------------------------------
f_cpi=cpi;
f_cpi_core=cpi_core;
f_pcepm=pcepm;
f_pcepm_core=pcepm_core;
[f_g_cpi,f_g_cpi_core,f_g_pcepm,f_g_pcepm_core]=fn_make_nowcasts(date_m,date_d,date_w,...
	p_gasoline_w,p_oil_d,g_cpi,g_cpi_core,g_cpi_food,g_cpi_gasoline,g_cpi_food_at_home,g_pcepm,g_pcepm_core,g_pcepm_goods_food,pce_switch_temp);	

%-------------------------------
% Convert growth rates to levels
%-------------------------------
f2=max(find(cpi~=junk_nos));
for i1=f2+1:ff+2;
	f_cpi(i1)=f_cpi(i1-1)*(1+f_g_cpi(i1)/100);
	f_cpi_core(i1)=f_cpi_core(i1-1)*(1+f_g_cpi_core(i1)/100);
end;
if pce_switch & pce_switch_temp;
f1=max(find(pcepm~=junk_nos));
for i1=f1+1:ff+2;
	f_pcepm(i1)=f_pcepm(i1-1)*(1+f_g_pcepm(i1)/100);
	f_pcepm_core(i1)=f_pcepm_core(i1-1)*(1+f_g_pcepm_core(i1)/100);
end;
end; % pce_switch

%------------------
% Save the nowcasts
%------------------
g_cpi_q_spf_model(qcount)=100*((mean(f_cpi(ff:ff+2))/mean(f_cpi(ff-3:ff-1)))^4-1);
g_cpi_core_q_spf_model(qcount)=100*((mean(f_cpi_core(ff:ff+2))/mean(f_cpi_core(ff-3:ff-1)))^4-1);
if pce_switch & pce_switch_temp;
g_pcep_q_spf_model(qcount)=100*((mean(f_pcepm(ff:ff+2))/mean(f_pcepm(ff-3:ff-1)))^4-1);
g_pcep_core_q_spf_model(qcount)=100*((mean(f_pcepm_core(ff:ff+2))/mean(f_pcepm_core(ff-3:ff-1)))^4-1);
end; % pce_switch

% SPF predicted:
g_cpi_q_spf(qcount)=spf_cpi_rt(find(date_q(qcount)==spf_cpi_rt(:,1)),find(date_cutoff==spf_cpi_rt(1,:)));
g_cpi_core_q_spf(qcount)=spf_cpi_core_rt(find(date_q(qcount)==spf_cpi_core_rt(:,1)),find(date_cutoff==spf_cpi_core_rt(1,:)));
g_pcep_q_spf(qcount)=spf_pcep_rt(find(date_q(qcount)==spf_pcep_rt(:,1)),find(date_cutoff==spf_pcep_rt(1,:)));
g_pcep_core_q_spf(qcount)=spf_pcep_core_rt(find(date_q(qcount)==spf_pcep_core_rt(:,1)),find(date_cutoff==spf_pcep_core_rt(1,:)));

%------------------------------
% Directional forecast accuracy
%------------------------------
for inf_counter=1:4;
%
if inf_counter==1;
% CPI
inf_model_this=g_cpi_q_spf_model(qcount);
inf_model_last=100*((mean(f_cpi(ff-3:ff-1))/mean(f_cpi(ff-6:ff-4)))^4-1);
inf_actual=g_cpi_q_metric(qcount);
inf_alt=g_cpi_q_spf(qcount);
inf_alt_last=spf_cpi_rt(find(date_q(qcount)==spf_cpi_rt(:,1))-1,find(date_cutoff==spf_cpi_rt(1,:)));
end;
% 
if inf_counter==2;
% Core CPI
inf_model_this=g_cpi_core_q_spf_model(qcount);
inf_model_last=100*((mean(f_cpi_core(ff-3:ff-1))/mean(f_cpi_core(ff-6:ff-4)))^4-1);
inf_actual=g_cpi_core_q_metric(qcount);
inf_alt=g_cpi_core_q_spf(qcount);
inf_alt_last=spf_cpi_core_rt(find(date_q(qcount)==spf_cpi_core_rt(:,1))-1,find(date_cutoff==spf_cpi_core_rt(1,:)));
end;
% 
if inf_counter>2;
%
if pce_switch & pce_switch_temp;
%
if inf_counter==3;
% PCE
inf_model_this=g_pcep_q_spf_model(qcount);
inf_model_last=100*((mean(f_pcepm(ff-3:ff-1))/mean(f_pcepm(ff-6:ff-4)))^4-1);
inf_actual=g_pcep_q_metric(qcount);
inf_alt=g_pcep_q_spf(qcount);
inf_alt_last=spf_pcep_rt(find(date_q(qcount)==spf_pcep_rt(:,1))-1,find(date_cutoff==spf_pcep_rt(1,:)));
end;
% 
if inf_counter==4;
% Core PCE
inf_model_this=g_pcep_core_q_spf_model(qcount);
inf_model_last=100*((mean(f_pcepm_core(ff-3:ff-1))/mean(f_pcepm_core(ff-6:ff-4)))^4-1);
inf_actual=g_pcep_core_q_metric(qcount);
inf_alt=g_pcep_core_q_spf(qcount);
inf_alt_last=spf_pcep_core_rt(find(date_q(qcount)==spf_pcep_core_rt(:,1))-1,find(date_cutoff==spf_pcep_core_rt(1,:)));
end;
% 
else
inf_model_this=junk_nos;
inf_alt=junk_nos;	
end;
%
end;
% only 1 case
case_count=1;
% 
% make sure have data
if inf_model_this~=junk_nos & inf_alt~=junk_nos;
%
% Nowcast
dfa_g_forecast_direction(qcount,case_count,inf_counter)=fn_dfa_up_indicator(inf_model_this,inf_model_last);
% Data
dfa_g_data_direction(qcount,case_count,inf_counter)=fn_dfa_up_indicator(inf_actual,inf_model_last);
% SPF
if inf_alt_last==junk_nos; % data were available, but not in SPF dataset
	dfa_g_forecast_direction_other(qcount,case_count,inf_counter)=fn_dfa_up_indicator(inf_alt,inf_model_last);
	dfa_g_data_direction_other(qcount,case_count,inf_counter)=fn_dfa_up_indicator(inf_actual,inf_model_last);
else; % use SPF nowcast from previous quarter
	dfa_g_forecast_direction_other(qcount,case_count,inf_counter)=fn_dfa_up_indicator(inf_alt,inf_alt_last);
	dfa_g_data_direction_other(qcount,case_count,inf_counter)=fn_dfa_up_indicator(inf_actual,inf_alt_last);
end;
%
end;
%
end;

%---------------------------------------------------------------------
end; % qcount loop
%---------------------------------------------------------------------

disp('-------------------------------------------------------------------------------');
disp('SPF is released in the middle of the middle month of the quarter.');
disp('Column 1=CPI');
disp('Column 2=Core CPI');
disp('Column 3=PCE');
disp('Column 4=Core PCE');
disp('-------------------------------------------------------------------------------');

%---------------------------------------------------------------------
% Directional forecast accuracy
%---------------------------------------------------------------------
pt_tests_model=NaN(3,1,4);
pt_tests_other=NaN(3,1,4);
for inf_counter=1:4;
i1=1; % only one case
	f1=dfa_g_forecast_direction(:,i1,inf_counter)~=junk_nos & dfa_g_data_direction(:,i1,inf_counter)~=junk_nos;
	[pt_tests_model(1,i1,inf_counter),pt_tests_model(2,i1,inf_counter),pt_tests_model(3,i1,inf_counter)]=...
		fn_pesaran_timmermann_sc_dfa(dfa_g_forecast_direction(f1,i1,inf_counter),dfa_g_data_direction(f1,i1,inf_counter));
	f1=dfa_g_forecast_direction_other(:,i1,inf_counter)~=junk_nos & dfa_g_data_direction_other(:,i1,inf_counter)~=junk_nos;
	[pt_tests_other(1,i1,inf_counter),pt_tests_other(2,i1,inf_counter),pt_tests_other(3,i1,inf_counter)]=...
		fn_pesaran_timmermann_sc_dfa(dfa_g_forecast_direction_other(f1,i1,inf_counter),dfa_g_data_direction_other(f1,i1,inf_counter));
%end;
end;
pt_tests_q_spf_model=squeeze(pt_tests_model);
pt_tests_q_spf=squeeze(pt_tests_other);

%---------------------------------------------------------------------
% Compute forecast errors
%---------------------------------------------------------------------
errors_q_spf_model=NaN*ones(length(date_q),4);
errors_q_spf=NaN*ones(length(date_q),4);
rmses_q_spf_model=NaN*ones(1,4);
rmses_q_spf=NaN*ones(1,4);
dmstat_q_spf_comp=NaN*ones(1,4);
dmstat_sig_q_spf_comp=NaN*ones(1,4);
gwstat_sig_q_spf_comp=NaN*ones(1,4);
no_obs_q_spf_comp=NaN*ones(1,4);
spf_dates_start_end=NaN*ones(2,4);
% CPI
f1=g_cpi_q_spf_model;
f2=g_cpi_q_spf;
a1=g_cpi_q_metric;
i2=f1~=junk_nos & f2~=junk_nos & a1~=junk_nos;
errors_q_spf_model(i2,1)=f1(i2)-a1(i2);
errors_q_spf(i2,1)=f2(i2)-a1(i2);
rmses_q_spf_model(1)=sqrt(mean((errors_q_spf_model(i2,1)).^2));
rmses_q_spf(1)=sqrt(mean((errors_q_spf(i2,1)).^2));
no_obs_q_spf_comp(1)=sum(i2);
[gw_teststat,gw_critval,gwstat_sig_q_spf_comp(1)]=CPAtest(errors_q_spf_model(i2,1).^2-errors_q_spf(i2,1).^2,ones(no_obs_q_spf_comp(1),1),1);
spf_dates_start_end(1,1)=date_q(min(find(i2)));
spf_dates_start_end(2,1)=date_q(max(find(i2)));
% Core CPI
f1=g_cpi_core_q_spf_model;
f2=g_cpi_core_q_spf;
a1=g_cpi_core_q_metric;
i2=f1~=junk_nos & f2~=junk_nos & a1~=junk_nos;
errors_q_spf_model(i2,2)=f1(i2)-a1(i2);
errors_q_spf(i2,2)=f2(i2)-a1(i2);
rmses_q_spf_model(2)=sqrt(mean((errors_q_spf_model(i2,2)).^2));
rmses_q_spf(2)=sqrt(mean((errors_q_spf(i2,2)).^2));
no_obs_q_spf_comp(2)=sum(i2);
[gw_teststat,gw_critval,gwstat_sig_q_spf_comp(2)]=CPAtest(errors_q_spf_model(i2,2).^2-errors_q_spf(i2,2).^2,ones(no_obs_q_spf_comp(2),1),1);
spf_dates_start_end(1,2)=date_q(min(find(i2)));
spf_dates_start_end(2,2)=date_q(max(find(i2)));
% PCE
f1=g_pcep_q_spf_model;
f2=g_pcep_q_spf;
a1=g_pcep_q_metric;
i2=f1~=junk_nos & f2~=junk_nos & a1~=junk_nos;
errors_q_spf_model(i2,3)=f1(i2)-a1(i2);
errors_q_spf(i2,3)=f2(i2)-a1(i2);
rmses_q_spf_model(3)=sqrt(mean((errors_q_spf_model(i2,3)).^2));
rmses_q_spf(3)=sqrt(mean((errors_q_spf(i2,3)).^2));
no_obs_q_spf_comp(3)=sum(i2);
[gw_teststat,gw_critval,gwstat_sig_q_spf_comp(3)]=CPAtest(errors_q_spf_model(i2,3).^2-errors_q_spf(i2,3).^2,ones(no_obs_q_spf_comp(3),1),1);
spf_dates_start_end(1,3)=date_q(min(find(i2)));
spf_dates_start_end(2,3)=date_q(max(find(i2)));
% Core PCE
f1=g_pcep_core_q_spf_model;
f2=g_pcep_core_q_spf;
a1=g_pcep_core_q_metric;
i2=f1~=junk_nos & f2~=junk_nos & a1~=junk_nos;
errors_q_spf_model(i2,4)=f1(i2)-a1(i2);
errors_q_spf(i2,4)=f2(i2)-a1(i2);
rmses_q_spf_model(4)=sqrt(mean((errors_q_spf_model(i2,4)).^2));
rmses_q_spf(4)=sqrt(mean((errors_q_spf(i2,4)).^2));
no_obs_q_spf_comp(4)=sum(i2);
[gw_teststat,gw_critval,gwstat_sig_q_spf_comp(4)]=CPAtest(errors_q_spf_model(i2,4).^2-errors_q_spf(i2,4).^2,ones(no_obs_q_spf_comp(4),1),1);
spf_dates_start_end(1,4)=date_q(min(find(i2)));
spf_dates_start_end(2,4)=date_q(max(find(i2)));
% Table 7 data:
table_7=[rmses_q_spf_model;rmses_q_spf;...
	(rmses_q_spf.^2)./(rmses_q_spf_model.^2);...
	gwstat_sig_q_spf_comp;...
	pt_tests_q_spf_model(3,:);...
	pt_tests_q_spf(3,:);
	pt_tests_q_spf_model(2,:);...
	pt_tests_q_spf(2,:)];
% Figure A2 data:
i1=date_q>=1999.2 & date_q<=2015.2;
figure_a2a=[date_q(i1),g_cpi_q_metric(i1),g_cpi_q_spf_model(i1),g_cpi_q_spf(i1)];
i1=date_q>=2007.1 & date_q<=2015.2;
figure_a2b=[date_q(i1),g_cpi_core_q_metric(i1),g_cpi_core_q_spf_model(i1),g_cpi_core_q_spf(i1)];
figure_a2c=[date_q(i1),g_pcep_q_metric(i1),g_pcep_q_spf_model(i1),g_pcep_q_spf(i1)];
figure_a2d=[date_q(i1),g_pcep_core_q_metric(i1),g_pcep_core_q_spf_model(i1),g_pcep_core_q_spf(i1)];






%---------------------------------------------------------------------
disp('-------------------------------------------------------------------------------');
disp('Greenbook horserace');
disp('-------------------------------------------------------------------------------');
%---------------------------------------------------------------------
% Compare the forecasting performance of the model with the Greenbook
% forecasts.  This is a date-based horserace, so information sets are
% matched by date.  The Greenbook is released 8 times per year, twice
% per quarter.  The exact release dates are irregular, but the general
% pattern is for the first GB in late January, the second in mid-March,
% the third in late April/early May, the fourth in late June, the fifth
% in early to mid-August, the sixth in mid-September, the seventh in 
% late October/early November, and the eighth in early December.  We 
% consider two cases, Greenbooks released in the first half of the 
% quarter and Greenbooks released in the second half of the quarter.
% Furthermore, we only consider nowcasting performance over the current
% quarter (i.e., Q1 for January and March GBs), because the exact timing
% of releases means that sometimes the GB would have all the Q4 data in
% January and others times not.
no_cases_gb=2;

% Load Greenbook nowcasts/forecasts
[gb_cpi_rt]=xlsread('nowcast_inflation_data','greenbook_cpi');
[gb_cpi_core_rt]=xlsread('nowcast_inflation_data','greenbook_cpi_core');
[gb_pcep_rt]=xlsread('nowcast_inflation_data','greenbook_pcep');
[gb_pcep_core_rt]=xlsread('nowcast_inflation_data','greenbook_pcep_core');
gb_cpi_rt(isnan(gb_cpi_rt))=junk_nos;
gb_cpi_core_rt(isnan(gb_cpi_core_rt))=junk_nos;
gb_pcep_rt(isnan(gb_pcep_rt))=junk_nos;
gb_pcep_core_rt(isnan(gb_pcep_core_rt))=junk_nos;

disp(['Quarter to start the Greenbook comparison: ',num2str(start_quarter_gb)]);
disp(['Quarter to end the Greenbook comparison: ',num2str(end_quarter_gb)]);

% set matrices to store inflation nowcasts
g_cpi_q_gb_model=junk_nos_q*ones(1,no_cases_gb);
g_cpi_core_q_gb_model=junk_nos_q*ones(1,no_cases_gb);
g_pcep_q_gb_model=junk_nos_q*ones(1,no_cases_gb);
g_pcep_core_q_gb_model=junk_nos_q*ones(1,no_cases_gb);
g_cpi_q_gb=junk_nos_q*ones(1,no_cases_gb);
g_cpi_core_q_gb=junk_nos_q*ones(1,no_cases_gb);
g_pcep_q_gb=junk_nos_q*ones(1,no_cases_gb);
g_pcep_core_q_gb=junk_nos_q*ones(1,no_cases_gb);

% Directional forecast accuracy matrices
dfa_g_forecast_direction=junk_nos*ones(length(date_q),no_cases_gb,4);
dfa_g_data_direction=junk_nos*ones(length(date_q),no_cases_gb,4);
%
dfa_g_forecast_direction_other=junk_nos*ones(length(date_q),no_cases_gb,4);
dfa_g_data_direction_other=junk_nos*ones(length(date_q),no_cases_gb,4);

%---------------------------------------------------------------------
for qcount=find(date_q==start_quarter_gb):find(date_q==end_quarter_gb);
%---------------------------------------------------------------------

yyyyq=date_q(qcount);
yy=round(yyyyq); % year of the quarter under investigation
mm=3*(round(10*rem(yyyyq,1))-1)+1; % first month of the quarter under investigation
yyyymm=yy+mm/100; % date of first month of the quarter under investigation
ff=find(date_m==yyyymm); % ff is the position of the first month of the quarter under investigation

%---------------------------------------------------------------------
for case_count=1:no_cases_gb;
%---------------------------------------------------------------------

if case_count==1;
	dc_low=yy*10000+mm*100+01;
	dc_high=yy*10000+(mm+1)*100+20;
end;
if case_count==2;
	dc_low=yy*10000+(mm+1)*100+21;
	dc_high=yy*10000+(mm+2)*100+31;
end;
date_cutoff=gb_cpi_rt(1,1+find(gb_cpi_rt(1,2:end)>=dc_low & gb_cpi_rt(1,2:end)<=dc_high));

%---------------------------------------------------------------------
% Set up available data
%---------------------------------------------------------------------
wcount=max(find(date_w<=date_cutoff));
dcount=max(find(date_d<=date_cutoff));
mcount_cpi=max(find(cpi_rt(1,:)<=date_cutoff));
mcount_cpi_core=max(find(cpi_core_rt(1,:)<=date_cutoff));
mcount_cpi_food=max(find(cpi_food_rt(1,:)<=date_cutoff));
mcount_cpi_gasoline=max(find(cpi_gasoline_rt(1,:)<=date_cutoff));
mcount_pcepm=max(find(pcepm_rt(1,:)<=date_cutoff));
if pce_switch;
pce_switch_temp=1;
if isempty(mcount_pcepm);
	pce_switch_temp=0;
end;
else pce_switch_temp=0;
end;
%
p_oil_d=junk_nos*ones(size(date_d));
p_oil_d(1:dcount)=p_oil_d_rt(1:dcount,2);
p_gasoline_w=junk_nos*ones(size(date_w));
p_gasoline_w(1:wcount)=p_gasoline_w_rt(1:wcount,2);
%
cpi=cpi_rt(2:end,mcount_cpi);
g_cpi=fn_compute_g_monthly(cpi);
cpi_core=cpi_core_rt(2:end,mcount_cpi_core);
g_cpi_core=fn_compute_g_monthly(cpi_core);
cpi_food=cpi_food_rt(2:end,mcount_cpi_food);
g_cpi_food=fn_compute_g_monthly(cpi_food);
cpi_gasoline=cpi_gasoline_rt(2:end,mcount_cpi_gasoline);
g_cpi_gasoline=fn_compute_g_monthly(cpi_gasoline);
% unfortunately, don't have real-time CPI--food at home (which 
% conceptually matches up with PCE--goods--food), use CPI--food instead
g_cpi_food_at_home=g_cpi_food;
%
if pce_switch & pce_switch_temp;
pcepm=pcepm_rt(2:end,mcount_pcepm);
g_pcepm=fn_compute_g_monthly(pcepm);
pcepm_core=pcepm_core_rt(2:end,mcount_pcepm);
g_pcepm_core=fn_compute_g_monthly(pcepm_core);
% unfortunately, don't have real-time PCE--goods--food, use CPI--food instead
g_pcepm_goods_food=g_cpi_food; 
else;
pcepm=[];
g_pcepm=[];
pcepm_core=[];
g_pcepm_core=[];
g_pcepm_goods_food=[];
end; % pce_switch

%---------------------------------------------------------------------
% Make nowcasts
%---------------------------------------------------------------------
f_cpi=cpi;
f_cpi_core=cpi_core;
f_pcepm=pcepm;
f_pcepm_core=pcepm_core;
[f_g_cpi,f_g_cpi_core,f_g_pcepm,f_g_pcepm_core]=fn_make_nowcasts(date_m,date_d,date_w,...
	p_gasoline_w,p_oil_d,g_cpi,g_cpi_core,g_cpi_food,g_cpi_gasoline,g_cpi_food_at_home,g_pcepm,g_pcepm_core,g_pcepm_goods_food,pce_switch_temp);

%-------------------------------
% Convert growth rates to levels
%-------------------------------
f2=max(find(cpi~=junk_nos));
for i1=f2+1:ff+2;
	f_cpi(i1)=f_cpi(i1-1)*(1+f_g_cpi(i1)/100);
	f_cpi_core(i1)=f_cpi_core(i1-1)*(1+f_g_cpi_core(i1)/100);
end;
if pce_switch & pce_switch_temp;
f1=max(find(pcepm~=junk_nos));
for i1=f1+1:ff+2;
	f_pcepm(i1)=f_pcepm(i1-1)*(1+f_g_pcepm(i1)/100);
	f_pcepm_core(i1)=f_pcepm_core(i1-1)*(1+f_g_pcepm_core(i1)/100);
end;
end; % pce_switch

%------------------
% Save the nowcasts
%------------------
g_cpi_q_gb_model(qcount,case_count)=100*((mean(f_cpi(ff:ff+2))/mean(f_cpi(ff-3:ff-1)))^4-1);
g_cpi_core_q_gb_model(qcount,case_count)=100*((mean(f_cpi_core(ff:ff+2))/mean(f_cpi_core(ff-3:ff-1)))^4-1);
if pce_switch & pce_switch_temp;
g_pcep_q_gb_model(qcount,case_count)=100*((mean(f_pcepm(ff:ff+2))/mean(f_pcepm(ff-3:ff-1)))^4-1);
g_pcep_core_q_gb_model(qcount,case_count)=100*((mean(f_pcepm_core(ff:ff+2))/mean(f_pcepm_core(ff-3:ff-1)))^4-1);
end; % pce_switch

% Greenbook predicted:
g_cpi_q_gb(qcount,case_count)=gb_cpi_rt(find(date_q(qcount)==gb_cpi_rt(:,1)),find(date_cutoff==gb_cpi_rt(1,:)));
g_cpi_core_q_gb(qcount,case_count)=gb_cpi_core_rt(find(date_q(qcount)==gb_cpi_core_rt(:,1)),find(date_cutoff==gb_cpi_core_rt(1,:)));
if ~isempty(gb_pcep_rt(find(date_q(qcount)==gb_pcep_rt(:,1)),find(date_cutoff==gb_pcep_rt(1,:))));
g_pcep_q_gb(qcount,case_count)=gb_pcep_rt(find(date_q(qcount)==gb_pcep_rt(:,1)),find(date_cutoff==gb_pcep_rt(1,:)));
end;
if ~isempty(gb_pcep_core_rt(find(date_q(qcount)==gb_pcep_core_rt(:,1)),find(date_cutoff==gb_pcep_core_rt(1,:))));
g_pcep_core_q_gb(qcount,case_count)=gb_pcep_core_rt(find(date_q(qcount)==gb_pcep_core_rt(:,1)),find(date_cutoff==gb_pcep_core_rt(1,:)));
end;

%------------------------------
% Directional forecast accuracy
%------------------------------
for inf_counter=1:4;
%
if inf_counter==1;
% CPI
inf_model_this=g_cpi_q_gb_model(qcount,case_count);
inf_model_last=100*((mean(f_cpi(ff-3:ff-1))/mean(f_cpi(ff-6:ff-4)))^4-1);
inf_actual=g_cpi_q_metric(qcount);
inf_alt=g_cpi_q_gb(qcount,case_count);
inf_alt_last=gb_cpi_rt(find(date_q(qcount)==gb_cpi_rt(:,1))-1,find(date_cutoff==gb_cpi_rt(1,:)));
end;
% 
if inf_counter==2;
% Core CPI
inf_model_this=g_cpi_core_q_gb_model(qcount,case_count);
inf_model_last=100*((mean(f_cpi_core(ff-3:ff-1))/mean(f_cpi_core(ff-6:ff-4)))^4-1);
inf_actual=g_cpi_core_q_metric(qcount);
inf_alt=g_cpi_core_q_gb(qcount,case_count);
inf_alt_last=gb_cpi_core_rt(find(date_q(qcount)==gb_cpi_core_rt(:,1))-1,find(date_cutoff==gb_cpi_core_rt(1,:)));
end;
% 
if inf_counter>2;
%
if pce_switch & pce_switch_temp;
%
if inf_counter==3;
% PCE
inf_model_this=g_pcep_q_gb_model(qcount,case_count);
inf_model_last=100*((mean(f_pcepm(ff-3:ff-1))/mean(f_pcepm(ff-6:ff-4)))^4-1);
inf_actual=g_pcep_q_metric(qcount);
inf_alt=g_pcep_q_gb(qcount,case_count);
inf_alt_last=gb_pcep_rt(find(date_q(qcount)==gb_pcep_rt(:,1))-1,find(date_cutoff==gb_pcep_rt(1,:)));
end;
% 
if inf_counter==4;
% Core PCE
inf_model_this=g_pcep_core_q_gb_model(qcount,case_count);
inf_model_last=100*((mean(f_pcepm_core(ff-3:ff-1))/mean(f_pcepm_core(ff-6:ff-4)))^4-1);
inf_actual=g_pcep_core_q_metric(qcount);
inf_alt=g_pcep_core_q_gb(qcount,case_count);
inf_alt_last=gb_pcep_core_rt(find(date_q(qcount)==gb_pcep_core_rt(:,1))-1,find(date_cutoff==gb_pcep_core_rt(1,:)));
end;
% 
else
inf_model_this=junk_nos;
inf_alt=junk_nos;	
end;
%
end;
% 
% make sure have data
if inf_model_this~=junk_nos & inf_alt~=junk_nos;
%
% Nowcast
dfa_g_forecast_direction(qcount,case_count,inf_counter)=fn_dfa_up_indicator(inf_model_this,inf_model_last);
% Data
dfa_g_data_direction(qcount,case_count,inf_counter)=fn_dfa_up_indicator(inf_actual,inf_model_last);
% GB
if inf_alt_last==junk_nos; % data were available, but not in GB dataset
	dfa_g_forecast_direction_other(qcount,case_count,inf_counter)=fn_dfa_up_indicator(inf_alt,inf_model_last);
	dfa_g_data_direction_other(qcount,case_count,inf_counter)=fn_dfa_up_indicator(inf_actual,inf_model_last);
else; % use GB nowcast from previous quarter
	dfa_g_forecast_direction_other(qcount,case_count,inf_counter)=fn_dfa_up_indicator(inf_alt,inf_alt_last);
	dfa_g_data_direction_other(qcount,case_count,inf_counter)=fn_dfa_up_indicator(inf_actual,inf_alt_last);
end;
%
end;
%
end;

%---------------------------------------------------------------------
end; % case_count loop
%---------------------------------------------------------------------

%---------------------------------------------------------------------
end; % qcount loop
%---------------------------------------------------------------------

disp('-------------------------------------------------------------------------------');
disp('Case 1:');
disp('First Greenbook of the quarter (typically in the first half of quarter)');
disp('-------------------------------------------------------------------------------');
disp('Case 2:');
disp('Second Greenbook of the quarter (typically in the second half of the quarter)');
disp('-------------------------------------------------------------------------------');

%---------------------------------------------------------------------
% Directional forecast accuracy
%---------------------------------------------------------------------
pt_tests_model=NaN(3,2,4);
pt_tests_other=NaN(3,2,4);
for inf_counter=1:4;
for i1=1:2;
	f1=dfa_g_forecast_direction(:,i1,inf_counter)~=junk_nos & dfa_g_data_direction(:,i1,inf_counter)~=junk_nos;
	[pt_tests_model(1,i1,inf_counter),pt_tests_model(2,i1,inf_counter),pt_tests_model(3,i1,inf_counter)]=...
		fn_pesaran_timmermann_sc_dfa(dfa_g_forecast_direction(f1,i1,inf_counter),dfa_g_data_direction(f1,i1,inf_counter));
	f1=dfa_g_forecast_direction_other(:,i1,inf_counter)~=junk_nos & dfa_g_data_direction_other(:,i1,inf_counter)~=junk_nos;
	[pt_tests_other(1,i1,inf_counter),pt_tests_other(2,i1,inf_counter),pt_tests_other(3,i1,inf_counter)]=...
		fn_pesaran_timmermann_sc_dfa(dfa_g_forecast_direction_other(f1,i1,inf_counter),dfa_g_data_direction_other(f1,i1,inf_counter));
end;
end;
pt_tests_q_gb_model=[pt_tests_model(:,:,1),pt_tests_model(:,:,2),pt_tests_model(:,:,3),pt_tests_model(:,:,4)];
pt_tests_q_gb=[pt_tests_other(:,:,1),pt_tests_other(:,:,2),pt_tests_other(:,:,3),pt_tests_other(:,:,4)];

%---------------------------------------------------------------------
% Compute forecast errors
%---------------------------------------------------------------------
errors_q_cpi_gb_model=NaN*ones(length(date_q),no_cases_gb);
errors_q_cpi_gb=NaN*ones(length(date_q),no_cases_gb);
errors_q_cpi_core_gb_model=NaN*ones(length(date_q),no_cases_gb);
errors_q_cpi_core_gb=NaN*ones(length(date_q),no_cases_gb);
errors_q_pcep_gb_model=NaN*ones(length(date_q),no_cases_gb);
errors_q_pcep_gb=NaN*ones(length(date_q),no_cases_gb);
errors_q_pcep_core_gb_model=NaN*ones(length(date_q),no_cases_gb);
errors_q_pcep_core_gb=NaN*ones(length(date_q),no_cases_gb);
rmses_q_cpi_gb_model=NaN*ones(1,no_cases_gb);
rmses_q_cpi_gb=NaN*ones(1,no_cases_gb);
rmses_q_cpi_core_gb_model=NaN*ones(1,no_cases_gb);
rmses_q_cpi_core_gb=NaN*ones(1,no_cases_gb);
rmses_q_pcep_gb_model=NaN*ones(1,no_cases_gb);
rmses_q_pcep_gb=NaN*ones(1,no_cases_gb);
rmses_q_pcep_core_gb_model=NaN*ones(1,no_cases_gb);
rmses_q_pcep_core_gb=NaN*ones(1,no_cases_gb);
gwstat_sig_q_cpi_gb_comp=NaN*ones(1,no_cases_gb);
gwstat_sig_q_cpi_core_gb_comp=NaN*ones(1,no_cases_gb);
gwstat_sig_q_pcep_gb_comp=NaN*ones(1,no_cases_gb);
gwstat_sig_q_pcep_core_gb_comp=NaN*ones(1,no_cases_gb);
no_obs_q_cpi_gb_comp=NaN*ones(1,no_cases_gb);
no_obs_q_cpi_core_gb_comp=NaN*ones(1,no_cases_gb);
no_obs_q_pcep_gb_comp=NaN*ones(1,no_cases_gb);
no_obs_q_pcep_core_gb_comp=NaN*ones(1,no_cases_gb);
gb_dates_start_end=NaN(2,8);
for i1=1:no_cases_gb;
	% CPI
	f1=g_cpi_q_gb_model(:,i1);
	% Greenbook CPI
	f2=g_cpi_q_gb(:,i1);
	% Actual
	a1=g_cpi_q_metric;
	i2=f1~=junk_nos & f2~=junk_nos & a1~=junk_nos;
	% Errors & RMSE
	errors_q_cpi_gb_model(i2,i1)=f1(i2)-a1(i2);
	rmses_q_cpi_gb_model(i1)=sqrt(mean((errors_q_cpi_gb_model(i2,i1)).^2));
	errors_q_cpi_gb(i2,i1)=f2(i2)-a1(i2);
	rmses_q_cpi_gb(i1)=sqrt(mean((errors_q_cpi_gb(i2,i1)).^2));
	% Check significance
	% number of observations
	no_obs_q_cpi_gb_comp(i1)=sum(i2);
	[gw_teststat,gw_critval,gwstat_sig_q_cpi_gb_comp(i1)]=CPAtest(errors_q_cpi_gb_model(i2,i1).^2-errors_q_cpi_gb(i2,i1).^2,ones(no_obs_q_cpi_gb_comp(i1),1),1);
	gb_dates_start_end(1,1)=date_q(min(find(i2)));
	gb_dates_start_end(2,1)=date_q(max(find(i2)));
	%
	% Core CPI
	f1=g_cpi_core_q_gb_model(:,i1);
	% Greenbook core CPI
	f2=g_cpi_core_q_gb(:,i1);
	% Actual
	a1=g_cpi_core_q_metric;
	i2=f1~=junk_nos & f2~=junk_nos & a1~=junk_nos;
	% Errors & RMSE
	errors_q_cpi_core_gb_model(i2,i1)=f1(i2)-a1(i2);
	rmses_q_cpi_core_gb_model(i1)=sqrt(mean((errors_q_cpi_core_gb_model(i2,i1)).^2));
	errors_q_cpi_core_gb(i2,i1)=f2(i2)-a1(i2);
	rmses_q_cpi_core_gb(i1)=sqrt(mean((errors_q_cpi_core_gb(i2,i1)).^2));
	% Check significance
	% number of observations
	no_obs_q_cpi_core_gb_comp(i1)=sum(i2);
	[gw_teststat,gw_critval,gwstat_sig_q_cpi_core_gb_comp(i1)]=CPAtest(errors_q_cpi_core_gb_model(i2,i1).^2-errors_q_cpi_core_gb(i2,i1).^2,ones(no_obs_q_cpi_core_gb_comp(i1),1),1);
	gb_dates_start_end(1,3)=date_q(min(find(i2)));
	gb_dates_start_end(2,3)=date_q(max(find(i2)));	
	%
	% PCEP
	f1=g_pcep_q_gb_model(:,i1);
	% Greenbook PCEP
	f2=g_pcep_q_gb(:,i1);
	% Actual
	a1=g_pcep_q_metric;
	i2=f1~=junk_nos & f2~=junk_nos & a1~=junk_nos & cond5;
	% Errors & RMSE
	errors_q_pcep_gb_model(i2,i1)=f1(i2)-a1(i2);
	rmses_q_pcep_gb_model(i1)=sqrt(mean((errors_q_pcep_gb_model(i2,i1)).^2));
	errors_q_pcep_gb(i2,i1)=f2(i2)-a1(i2);
	rmses_q_pcep_gb(i1)=sqrt(mean((errors_q_pcep_gb(i2,i1)).^2));
	% Check significance
	% number of observations
	no_obs_q_pcep_gb_comp(i1)=sum(i2);
	[gw_teststat,gw_critval,gwstat_sig_q_pcep_gb_comp(i1)]=CPAtest(errors_q_pcep_gb_model(i2,i1).^2-errors_q_pcep_gb(i2,i1).^2,ones(no_obs_q_pcep_gb_comp(i1),1),1);
	gb_dates_start_end(1,5)=date_q(min(find(i2)));
	gb_dates_start_end(2,5)=date_q(max(find(i2)));	
	%
	% Core PCEP
	f1=g_pcep_core_q_gb_model(:,i1);
	% Greenbook core PCEP
	f2=g_pcep_core_q_gb(:,i1);
	% Actual
	a1=g_pcep_core_q_metric;
	i2=f1~=junk_nos & f2~=junk_nos & a1~=junk_nos & cond3;
	% Errors & RMSE
	errors_q_pcep_core_gb_model(i2,i1)=f1(i2)-a1(i2);
	rmses_q_pcep_core_gb_model(i1)=sqrt(mean((errors_q_pcep_core_gb_model(i2,i1)).^2));
	errors_q_pcep_core_gb(i2,i1)=f2(i2)-a1(i2);
	rmses_q_pcep_core_gb(i1)=sqrt(mean((errors_q_pcep_core_gb(i2,i1)).^2));
	% Check significance
	% number of observations
	no_obs_q_pcep_core_gb_comp(i1)=sum(i2);
	[gw_teststat,gw_critval,gwstat_sig_q_pcep_core_gb_comp(i1)]=CPAtest(errors_q_pcep_core_gb_model(i2,i1).^2-errors_q_pcep_core_gb(i2,i1).^2,ones(no_obs_q_pcep_core_gb_comp(i1),1),1);
	gb_dates_start_end(1,7)=date_q(min(find(i2)));
	gb_dates_start_end(2,7)=date_q(max(find(i2)));		
end;
% Table 8 data:
table_8=[rmses_q_cpi_gb_model,rmses_q_cpi_core_gb_model,rmses_q_pcep_gb_model,rmses_q_pcep_core_gb_model;...
	rmses_q_cpi_gb,rmses_q_cpi_core_gb,rmses_q_pcep_gb,rmses_q_pcep_core_gb;...
	(rmses_q_cpi_gb.^2)./(rmses_q_cpi_gb_model.^2),(rmses_q_cpi_core_gb.^2)./(rmses_q_cpi_core_gb_model.^2),...
	(rmses_q_pcep_gb.^2)./(rmses_q_pcep_gb_model.^2),(rmses_q_pcep_core_gb.^2)./(rmses_q_pcep_core_gb_model.^2);...
	gwstat_sig_q_cpi_gb_comp,gwstat_sig_q_cpi_core_gb_comp,...
	gwstat_sig_q_pcep_gb_comp,gwstat_sig_q_pcep_core_gb_comp;...
	pt_tests_q_gb_model(3,:);...
	pt_tests_q_gb(3,:);...
	pt_tests_q_gb_model(2,:);...
	pt_tests_q_gb(2,:)];
% Figure A3 data:
i1=date_q>=1999.2 & date_q<=2009.4;
figure_a3a=[date_q(i1),g_cpi_q_metric(i1),g_cpi_q_gb_model(i1,1),g_cpi_q_gb(i1,1)];
figure_a3b=[date_q(i1),g_cpi_q_metric(i1),g_cpi_q_gb_model(i1,2),g_cpi_q_gb(i1,2)];
figure_a3c=[date_q(i1),g_cpi_core_q_metric(i1),g_cpi_core_q_gb_model(i1,1),g_cpi_core_q_gb(i1,1)];
figure_a3d=[date_q(i1),g_cpi_core_q_metric(i1),g_cpi_core_q_gb_model(i1,2),g_cpi_core_q_gb(i1,2)];  
i1=date_q>=2000.3 & date_q<=2009.4; % PCE inflation rates not previously in Greenbook
figure_a3e=[date_q(i1),g_pcep_q_metric(i1),g_pcep_q_gb_model(i1,1),g_pcep_q_gb(i1,1)];
figure_a3f=[date_q(i1),g_pcep_q_metric(i1),g_pcep_q_gb_model(i1,2),g_pcep_q_gb(i1,2)];
figure_a3g=[date_q(i1),g_pcep_core_q_metric(i1),g_pcep_core_q_gb_model(i1,1),g_pcep_core_q_gb(i1,1)];
figure_a3h=[date_q(i1),g_pcep_core_q_metric(i1),g_pcep_core_q_gb_model(i1,2),g_pcep_core_q_gb(i1,2)];


	



%---------------------------------------------------------------------
disp('-------------------------------------------------------------------------------');
disp('2013Q2 nowcasting experiment');
disp('-------------------------------------------------------------------------------');
%---------------------------------------------------------------------
% nowcast headline CPI for 2013Q2
nowcast_cpi_q_2013q2_counter=1;
g_cpi_q_2013q2_exercise=junk_nos*ones(107,2);

%---------------------------------------------------------------------
% month loop
for month_count=4:7;
%---------------------------------------------------------------------
	
%---------------------------------------------------------------------
% day loop
if month_count==4; day_count_max=30; end;
if month_count==5; day_count_max=31; end;
if month_count==6; day_count_max=30; end;
if month_count==7; day_count_max=16; end;
for day_count=1:day_count_max;
%---------------------------------------------------------------------

yyyyq=2013.2;
yyyymm=2013.04;
ff=find(date_m==yyyymm); % ff is the position of the first month of the quarter under investigation
date_cutoff=20130000+month_count*100+day_count;

%---------------------------------------------------------------------
% Set up available data
%---------------------------------------------------------------------
wcount=max(find(date_w<=date_cutoff));
dcount=max(find(date_d<=date_cutoff));
mcount_cpi=max(find(cpi_rt(1,:)<=date_cutoff));
mcount_cpi_core=max(find(cpi_core_rt(1,:)<=date_cutoff));
mcount_cpi_food=max(find(cpi_food_rt(1,:)<=date_cutoff));
mcount_cpi_gasoline=max(find(cpi_gasoline_rt(1,:)<=date_cutoff));
%
p_oil_d=junk_nos*ones(size(date_d));
p_oil_d(1:dcount)=p_oil_d_rt(1:dcount,2);
p_gasoline_w=junk_nos*ones(size(date_w));
p_gasoline_w(1:wcount)=p_gasoline_w_rt(1:wcount,2);
%
cpi=cpi_rt(2:end,mcount_cpi);
g_cpi=fn_compute_g_monthly(cpi);
cpi_core=cpi_core_rt(2:end,mcount_cpi_core);
g_cpi_core=fn_compute_g_monthly(cpi_core);
cpi_food=cpi_food_rt(2:end,mcount_cpi_food);
g_cpi_food=fn_compute_g_monthly(cpi_food);
cpi_gasoline=cpi_gasoline_rt(2:end,mcount_cpi_gasoline);
g_cpi_gasoline=fn_compute_g_monthly(cpi_gasoline);
        
%---------------------------------------------------------------------
% Make nowcasts
%---------------------------------------------------------------------        
f_cpi=cpi;
[f_g_cpi]=fn_make_nowcasts(date_m,date_d,date_w,...
	p_gasoline_w,p_oil_d,g_cpi,g_cpi_core,g_cpi_food,g_cpi_gasoline);

%-------------------------------
% Convert growth rates to levels
%-------------------------------
f2=max(find(cpi~=junk_nos));
for i1=f2+1:ff+2;
	f_cpi(i1)=f_cpi(i1-1)*(1+f_g_cpi(i1)/100);
end;

%------------------
% Save the nowcasts
%------------------
g_cpi_q_2013q2_exercise(nowcast_cpi_q_2013q2_counter,1)=date_cutoff;
g_cpi_q_2013q2_exercise(nowcast_cpi_q_2013q2_counter,2)=100*((mean(f_cpi(ff:ff+2))/mean(f_cpi(ff-3:ff-1)))^4-1);
nowcast_cpi_q_2013q2_counter=nowcast_cpi_q_2013q2_counter+1;

%---------------------------------------------------------------------
end; % end day loop
%---------------------------------------------------------------------

%---------------------------------------------------------------------
end; % end month loop
%---------------------------------------------------------------------
% Figure A4
figure_a4=g_cpi_q_2013q2_exercise;